##MAME Library Builder v1.1#
##Dracrius - Aug 20th 2019##

$file_list = Get-Content ROMs_List.txt
$folder_list = Get-Content Folders_List.txt

$root_folder = "*MAME*"
$destination_folder = "Building MAME SubLibrary... ($((Get-Date).ToString('MMM, dd, yyyy h-mm tt')))"
$final_folder =  "Arcade Library ($((Get-Date).ToString('MMM, dd, yyyy h-mm tt')))"

$roms_folder = "$root_folder\ROMs"
$artwork_folder = "$root_folder\Artwork"
$cabinets_folder = "$root_folder\Cabinets"
$cpanel_folder = "$root_folder\CPanel"
$flyers_folder = "$root_folder\Flyers"
$icons_folder = "$root_folder\Icons"
$manuals_folder = "$root_folder\Manuals"
$marquees_folder = "$root_folder\Marquees"
$pcb_folder = "$root_folder\PCB"
$samples_folder = "$root_folder\Samples"
$snap_folder = "$root_folder\Snap"
$soundtrack_folder = "$root_folder\Soundtrack"
$titles_folder = "$root_folder\Titles"
$videosnaps_folder = "$root_folder\VideoSnaps"

Write-Output "Welcome to MAME Library Builder"
Write-Output "`n"
Write-Output "Creating Library Directories..."

New-Item -Type dir "$destination_folder\ROMs"
New-Item -Type dir "$destination_folder\Artwork"
New-Item -Type dir "$destination_folder\Cabinets"
New-Item -Type dir "$destination_folder\CPanel"
New-Item -Type dir "$destination_folder\Flyers"
New-Item -Type dir "$destination_folder\Icons"
New-Item -Type dir "$destination_folder\Manuals"
New-Item -Type dir "$destination_folder\Marquees"
New-Item -Type dir "$destination_folder\PCB"
New-Item -Type dir "$destination_folder\Samples"
New-Item -Type dir "$destination_folder\Snap"
New-Item -Type dir "$destination_folder\Soundtrack"
New-Item -Type dir "$destination_folder\Titles"
New-Item -Type dir "$destination_folder\VideoSnaps"

Write-Output "`n"
Write-Output "Setting Working Directories..."



$roms_destination_folder = "$destination_folder\ROMs"
$artwork_destination_folder = "$destination_folder\Artwork"
$cabinets_destination_folder = "$destination_folder\Cabinets"
$cpanel_destination_folder = "$destination_folder\CPanel"
$flyers_destination_folder = "$destination_folder\Flyers"
$icons_destination_folder = "$destination_folder\Icons"
$manuals_destination_folder = "$destination_folder\Manuals"
$marquees_destination_folder = "$destination_folder\Marquees"
$pcb_destination_folder = "$destination_folder\PCB"
$samples_destination_folder = "$destination_folder\Samples"
$snap_destination_folder = "$destination_folder\Snap"
$soundtrack_destination_folder = "$destination_folder\Soundtrack"
$titles_destination_folder = "$destination_folder\Titles"
$videosnaps_destination_folder = "$destination_folder\VideoSnaps"

Write-Output "`n"
Write-Output "Parsing ROMs_List.txt and Beginning to Copy to SubLibrary..."


foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $roms_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $roms_destination_folder
    }
}

Write-Output "ROM's Copied Successfully moving on to Artwork..."
	
foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $artwork_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) { 
        Copy-Item $file_to_copy $artwork_destination_folder
    }
}

Write-Output "Artwork Copied Successfully moving on to Cabinets..."
	
foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $cabinets_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $cabinets_destination_folder
    }
}

Write-Output "Cabinets Copied Successfully moving on to CPanel..."
	
foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $cpanel_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $cpanel_destination_folder
    }

}

Write-Output "CPanel Copied Successfully moving on to Flyers..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $flyers_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $flyers_destination_folder
    }
}

Write-Output "Flyers Copied Successfully moving on to Icons..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $icons_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $icons_destination_folder
    }
}

Write-Output "Icons Copied Successfully moving on to Manuals..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $manuals_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $manuals_destination_folder
    }
}

Write-Output "Manuals Copied Successfully moving on to Marquees..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $marquees_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $marquees_destination_folder
    }
}

Write-Output "Marquees Copied Successfully moving on to PCB..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $pcb_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $pcb_destination_folder
    }
}

Write-Output "PCB Copied Successfully moving on to Samples..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $samples_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $samples_destination_folder
    }
}

Write-Output "Samples Copied Successfully moving on to Snap..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $snap_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $snap_destination_folder
    }
}

Write-Output "Snap Copied Successfully moving on to Soundtrack..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $soundtrack_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $soundtrack_destination_folder
    }
}

Write-Output "Soundtrack Copied Successfully moving on to Titles..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $titles_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $titles_destination_folder
    }
}

Write-Output "Titles Copied Successfully moving on to VideoSnaps..."

foreach ($file in $file_list) {
    $file_to_copy = Get-ChildItem -Path $videosnaps_folder -Filter $file -Recurse -ErrorAction SilentlyContinue -Force | % { $_.FullName}
    if ($file_to_copy) {
        Copy-Item $file_to_copy $videosnaps_destination_folder
    }
}

Write-Output "Individual Files Complete!"
Rename-Item $destination_folder $final_folder
Write-Output "`n"
Write-Output "Parsing Folders_List.txt and Beginning Complete Folder Copying..."

foreach ($folder in $folder_list) {
        Copy-Item $root_folder\$folder -Destination $final_folder\$folder -Recurse
    }
	
Write-Output "`n"
Write-Output "SubLibrary Creation Complete!"
Write-Output "MAME Library Builder will automatically close in 10s..."
Start-Sleep -s 10
